// Complex.h
/* 
   CS 202, Homework#4
   Problem 1
   Author: Harish Kumar
*/

// Declaration of class Complex
// Member functions defined in Complex.cpp
// prevent multiple inclusion of header file

#ifndef COMPLEX_H
#define COMPLEX_H

// class definition 

class Complex
{
public:
Complex( double = 0.0, double = 0.0); // default constructor
void add( Complex, Complex ); // add two complex numbers
void sub( Complex, Complex ); // subtracts two complex numbers
void mul( Complex, Complex ); // multiplies two complex numbers
void print( void ); // prints complex number in the form (real, img)
private:
	double realpart;
	double imgpart;
}; // end of class Complex

#endif // COMPLEX_H


// Complex.cpp
/* 
   CS 202, Homework#4
   Problem 1
   Author: Harish Kumar
*/
// Member function definitions for class Complex

#include <iostream>
using std::cout;
using std::endl;

//#include "Complex.h" // include class Complex

// Complex constructor initializes objects of this class 
Complex::Complex(double a, double b)
{
	realpart = a;
	imgpart = b;
} // end constructor Complex

// adds two complex numbers
void Complex::add( Complex a, Complex b)
{
	realpart = a.realpart + b.realpart;
	imgpart = a.imgpart + b.imgpart;
} // end function add

// subtracts two complex numbers
void Complex::sub( Complex a, Complex b)
{
	realpart = a.realpart - b.realpart;
	imgpart = a.imgpart - b.imgpart;
} // end function sub

// multiplies two complex numbers
void Complex::mul( Complex a, Complex b)
{
	realpart = (a.realpart*b.realpart) - (a.imgpart*b.imgpart);
	imgpart = (a.realpart*b.imgpart) + (a.imgpart*b.realpart);
} // end function mul

// prints the complex number in the form (realpart, imgpart)
void Complex::print()
{
	cout<<endl<< "(" << realpart << ", " << imgpart << ")"<<endl;
}// end function print

// Driver.cpp
/* 
   CS 202, Homework#4
   Problem 1
   Author: Harish Kumar
*/
// Driver program to test Complex class

#include <iostream>
using std::cout;
using std::endl;

//#include "Complex.h" // include class Complex

// begin main
int main()
{
	Complex a(1.0,1.0), b(-1.0,1.0), c; // Declaring 3 Complex class 
objects
	cout<< "The Complex Numbers are:";
	a.print();  b.print();
	c.add(a,b); // c = a + b
	cout<< "After Adding The Complex Numbers:";
	c.print();
	c.sub(a,b); // c = a - b
	cout<< "After Subtracting The Complex Numbers:";
	c.print();
	c.mul(a,b); // c = a * b
	cout<< "After Multiplying The Complex Numbers:";
	c.print();

	return 0;
} // end main

// OUTPUT

/*
The Complex Numbers are:
(1, 1)
(-1, 1)
After Adding The Complex Numbers:
(0, 2)
After Subtracting The Complex Numbers:
(2, 0)
After Multiplying The Complex Numbers:
(-2, 0)
*/

